use std::{collections::HashMap, fmt::Display};

use crate::domain::game::Game;


pub struct OwnedGames<'a>(pub &'a HashMap<String, Vec<Game>>);

impl<'a> Display for OwnedGames<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        for (k,v) in self.0 {
            write!(f, "{k}:\n")?;
            for g in v {
                write!(f, "\t{}\n", g.name)?;
            }
        }
        Ok(())
    }
}